import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Robot here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Robot extends Actor
{
    private GreenfootImage robotImage1= new GreenfootImage ("man01.png");
    private GreenfootImage robotImage2= new GreenfootImage ("man02.png");
    private GreenfootImage gameOverImage= new GreenfootImage ("gameover.png");
    private int animateCounter;
    private int lives=3;
    private int score;
    private int pizzaEaten;
    private int timer;
    /**
     * Act - do whatever the Robot wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        robotMovement();
        detectWallColision();
        detectBlockColision();
        eatPizza();
        detectHome();
        showStatus();
        updateTimer();
    }
    //moviment de Robot
    public void robotMovement()
    {
        if (Greenfoot.isKeyDown("right"))
        {
            setLocation(getX()+3,getY());
            animate();
        }
        if (Greenfoot.isKeyDown("left"))
        {
            setLocation(getX()-3,getY());
            animate();
        }
        if (Greenfoot.isKeyDown("up"))
        {
            setLocation(getX(),getY()-3);
            animate();
        }
        if (Greenfoot.isKeyDown("down"))
        {
            setLocation(getX(),getY()+3);
            animate();
        }
    }
    //colisio de Robot amb Wall
    public void detectWallColision()
    {
        if (isTouching(Wall.class))
        {
            setLocation(70,57);
            Greenfoot.playSound("hurt.wav");
            removeLive();
        }
    }
    //colisio de Robot amb Block
    public void detectBlockColision()
    {
        if (isTouching(Block.class))
        {
            setLocation(70,57);
            Greenfoot.playSound("hurt.wav");
            removeLive();
        }
    }
    //Robot menja Pizza
    public void eatPizza()
    {
        if (isTouching(Pizza.class))
        {
            removeTouching(Pizza.class);
            Greenfoot.playSound("eat.wav");
            pizzaEaten++;
            timer=timer+200;
        }
    }
    //colisio de Robot amb Home
    public void detectHome()
    {
        if (isTouching(Home.class)&&pizzaEaten==5)
        {
            Greenfoot.playSound("yipee.wav");
            setLocation(70,57);
            increaseScore();
            pizzaEaten=0;
            RobotWorld myworld=(RobotWorld)getWorld();
            myworld.increaseLevel();
            timer=1000;
        }
    }
    //animacio Robot caminant
    public void animate()
    {
        animateCounter++;
        if (animateCounter>5)
        {
            animateCounter=0;
            if (getImage() == robotImage1)
            {
                setImage (robotImage2);
            }
            else {
                setImage (robotImage1);
            }
        }
    }
    public void removeLive()
    {
        lives--;
        testEndGame();
        showStatus();
    }
    public void testEndGame()
    {
        if (lives<=0)
        {
            setImage (gameOverImage);
            Greenfoot.stop();
            
        }
    }
    public void increaseScore()
    {
        score++;
        showStatus();
    }
    public void showStatus()
     {
         getWorld().showText("Lives : " + lives,80,545);
         getWorld().showText("Score : " + score,80,525);
        }
    public Robot()
    {
        timer=1000;
    }
    public void updateTimer()
    {
        timer--;
        getWorld().showText("Time left: "+timer,100,590);
        if (timer==0)
        {
            removeLive();
            setLocation(50,50);
            timer=1000;
        }
    }
    }
